#!/usr/bin/perl

# Aufruf: ./fetch-min-time-from-db-fair-csv.pl verfahren1 verfahren2
# Liefert die "besten" Zeiten von verfahren1 (mit FP) und verfahren2 (ohne FP)

use Pg;

@experimente = ('build', 'pos_lkp', 'neg_lkp', 'delins' );


$conn = Pg::connectdb("host=kt16.theoinf.tu-ilmenau.de dbname=cuckoo-experimente user=weidling password=gl_1984*");

$verf_mit=13;

if ( @ARGV > 0 ) {
    $verf_mit = $ARGV[0];
}

$verf_ohne = $verf_mit+1;

if ( @ARGV > 1 ) {
    $verf_ohne = $ARGV[1];
}

@verfahren=($verf_mit, $verf_ohne);


$select = "select distinct epsilon from data where verfahren=$verf_mit or verfahren=$verf_ohne order by epsilon desc";
$res_eps = $conn->exec( $select );

print "# epsilon\tbuild(fp)\tbuild(ohne fp)\tpos_lkp(fp)\tpos_lkp(ohne fp)\tneg_lkp(fp)\tneg_lkp(ohne fp)\tdelins(fp)\tdelinsp(ohne fp)\n";

while( @r_eps = $res_eps->fetchrow ){
 $eps = $r_eps[0];
  $eps_min=0.9999*$eps;
  $eps_max=1.00001*$eps;
  print $eps;
  foreach $experiment (@experimente) {
    foreach $v (@verfahren) {
      $select = "select $experiment from data where verfahren=$v and epsilon between $eps_min and $eps_max order by $experiment limit 1";
      $res = $conn->exec( $select );
      if( @row = $res->fetchrow ){
        print "\t", $row[0];
      } else {
        print "\t-";
      }
    }
  }
  print "\n";
}


